package io.zipcoder;

import java.util.Stack;

public class ParenChecker {
    Stack<Character> stack = new Stack<>();
    Stack<Character> stack2 = new Stack<>();


    public boolean checkParens(String input) {
        for (int i = 0; i < input.length(); i++) {
            char pos = input.charAt(i); //pos = position

            if (pos == '(') {
                stack.push(pos);
            }
            if (pos == ')') {
                if (stack.contains('(')) {
                    stack.pop();
                } else return false;
            }
        }

        if (stack.size() == 0) return true;
        return false;
    }

    public boolean checkPairs(String input) {
        char last = '\0';
        for (int i = 0; i < input.length(); i++) {
            char pos = input.charAt(i);
            if (pos == '(' || pos == '{' || pos == '[' || pos == '<') {
                stack.push(pos);
                last = stack.peek();
                continue;
            }

            switch (pos) {
                case ')':
                    if (last == '(') {
                        stack.pop();
                        last = stack.size() > 0 ? stack.peek(): '\0';
                    } else {
                        System.out.println("Must open parentheses '(' or close other character first");
                        return false;
                    }
                    break;
                case '}':
                    if (last == '{') {
                        stack.pop();
                        last = stack.size() > 0 ? stack.peek(): '\0';
                    } else {
                        System.out.println("Must open brace '{' or close other character first");
                        return false;
                    }
                    break;
                case ']':
                    if (last == '[') {
                        stack.pop();
                        last = stack.size() > 0 ? stack.peek(): '\0';
                    } else {
                        System.out.println("Must open bracket '[' or close other character first");
                        return false;
                    }
                    break;
                case '>':
                    if (last == '<') {
                        stack.pop();
                        last = stack.size() > 0 ? stack.peek(): '\0';;
                    } else {
                        System.out.println("Must open diamond bracket '<' or close other character first");
                        return false;
                    }
                    break;
                case '\"':
                    if (last == '\"') {
                        stack.pop();
                        last = stack.size() > 0 ? stack.peek(): '\0';
                    } else {
                        stack.push(pos);
                        last = stack.size() > 0 ? stack.peek(): '\0';
                    }
                    break;
                case '\'':
                    if (last == '\'') {
                        stack.pop();
                        last = stack.size() > 0 ? stack.peek(): '\0';
                    } else {
                        stack.push(pos);
                        last = stack.size() > 0 ? stack.peek(): '\0';
                    }
                    break;
            }
        }

        if (stack.size() == 0) return true;
        else {
            System.out.println("stack size is " + stack.size());
            stack.forEach(character -> System.out.println("Need to close " + character + " first."));
            return false;
        }
    }


}
